tp_obj print(tp_obj params) {
    P_BEGIN(params);
    int n = 0;
    tp_obj e;
    P_LOOP_BEGIN(e)
        if (n) { printf(" "); }
        printf("%s",tp_cstring(tp_str(e)));
        n += 1;
    P_LOOP_END;
    P_END;
    printf("\n");
    return None;
}

tp_obj bind(tp_obj params) {
    P_BEGIN(params);
    tp_obj r = P_OBJ("fnc");
    tp_obj self = P_OBJ("self");
    P_END;
    r.fnc.self = tp_ptr(self);
    return r;
}

tp_obj min(tp_obj params) {
    P_BEGIN(params);
    tp_obj r = P_POP();
    tp_obj e;
    P_LOOP_BEGIN(e)
        if (tp_cmp(r,e).number.value > 0) { r = e; }
    P_LOOP_END;
    P_END;
    return r;
}

tp_obj max(tp_obj params) {
    P_BEGIN(params);
    tp_obj r = P_POP();
    tp_obj e;
    P_LOOP_BEGIN(e)
        if (tp_cmp(r,e).number.value < 0) { r = e; }
    P_LOOP_END;
    P_END;
    return r;
}

tp_obj tp_copy(tp_obj params) {
    P_BEGIN(params);
    tp_obj r = P_OBJ("value");
    P_END;
    int type = r.type;
    if (type == TP_LIST) {
        r.list.value = _tp_list_copy(r.list.value);
    } else if (type == TP_DICT) {
        r.dict.value = _tp_dict_copy(r.dict.value);
    } else if (type == TP_PARAMS) {
        r.list.value = _tp_list_copy(r.list.value);
        r.dict.value = _tp_dict_copy(r.dict.value);
    }
    return r;
}


tp_obj len(tp_obj params) {
    P_BEGIN(params);
    tp_obj e = P_OBJ("value");
    P_END;
    return tp_len(e);
}


tp_obj tp_assert(tp_obj params) {
    P_BEGIN(params);
    int a = P_NUMBER("value");
    P_END;
    if (a) { return None; }
    vm_raise("%s","assert failed");
}

tp_obj range(tp_obj params) {
    P_BEGIN(params);
    int a = P_NUMBER("a");
    int b = P_NUMBER("b");
    int c = P_DEFAULT("c",tp_number(1)).number.value;
    P_END;
    tp_obj r = tp_list(0,0);
    int i;
    for (i=a; i<b; i+=c) {
        _tp_list_append(r.list.value,tp_ptr(tp_number(i)));
    }
    return r;
}


tp_obj tp_system(tp_obj params) {
    P_BEGIN(params);
    char *s = P_STRING("value");
    P_END;
    int r = system(s);
    return tp_number(r);
}

tp_obj tp_istype(tp_obj params) {
    P_BEGIN(params);
    tp_obj v = P_OBJ("value");
    char *t = P_STRING("type");
    P_END;
    if (strcmp("string",t) == 0) { return tp_number(v.type == TP_STRING); }
    if (strcmp("list",t) == 0) { return tp_number(v.type == TP_LIST); }
    if (strcmp("dict",t) == 0) { return tp_number(v.type == TP_DICT); }
    if (strcmp("number",t) == 0) { return tp_number(v.type == TP_NUMBER); }
    vm_raise("is_type(%s,%s)",STR(v),t);
}


tp_obj tp_float(tp_obj params) {
    P_BEGIN(params);
    tp_obj v = P_OBJ("value");
    P_END;
    int type = v.type;
    if (type == TP_NUMBER) {
        return v;
    } else if (type == TP_STRING) {
        return tp_number(atof(tp_cstring(v)));
    }
    vm_raise("tp_float(%s)",STR(v));
}


tp_obj tp_save(tp_obj params) {
    P_BEGIN(params);
    char *fname = P_STRING("fname");
    tp_obj v = P_OBJ("value");
    P_END;
    FILE *f;
    f = fopen(fname,"wb");
    if (!f) { vm_raise("tp_save(%s,...)",fname); }
    fwrite(v.string.buf,v.string.length,1,f);
    fclose(f);
    return None;
}

tp_obj tp_load(tp_obj params) {
    P_BEGIN(params);
    char *fname = P_STRING("fname");
    P_END;
    FILE *f;
    f = fopen(fname,"rb");
    if (!f) { vm_raise("tp_load(%s)",fname); }
    long l = FileSize(fname);
    char *s = tp_malloc(l+1); s[l]=0;
    fread(s,1,l,f);
    fclose(f);
    return tp_string_n(s,l);
}


tp_obj tp_fpack(tp_obj params) {
    P_BEGIN(params);
    float v = P_NUMBER("value");
    P_END;
    float *r = tp_malloc(sizeof(v)); *r = v;
    return tp_string_n((char*)r,sizeof(v));
}

tp_obj tp_abs(tp_obj params) {
    P_BEGIN(params);
    tp_obj e = P_OBJ("value");
    P_END;
    return tp_number(fabs(e.number.value));
}
tp_obj tp_int(tp_obj params) {
    return tp_number((int)tp_float(params).number.value);
}

tp_obj tp_exists(tp_obj params) {
    P_BEGIN(params);
    char *s = P_STRING("fname");
    P_END;
    struct stat stbuf;
    return tp_number(!stat(s,&stbuf));
}
tp_obj tp_mtime(tp_obj params) {
    P_BEGIN(params);
    char *s = P_STRING("fname");
    P_END;
    struct stat stbuf;
    if (!stat(s,&stbuf)) { return tp_number(stbuf.st_mtime); }
    vm_raise("tp_mtime(%s)",s);
}

