void _tp_list_tp_realloc(_tp_list *self,int len) {
    int i;
    if (!len) { len=1; }
    self->items = tp_realloc(self->items,len*sizeof(void *));
    for (i=self->alloc; i<len; i++) {
        self->items[i] = 0;
    }
    self->alloc = len;
}

void _tp_list_set(_tp_list *self,int k, void *v, char *error) {
    if (k >= self->length) {
        vm_raise("%s: KeyError: %d\n",error,k);
        return;
    }
    self->items[k] = v;
}

void *_tp_list_get(_tp_list *self,int k,char *error) {
    if (k >= self->length) {
        vm_raise("%s: KeyError: %d\n",error,k);
        return 0;
    }
    return self->items[k];
}
void _tp_list_append(_tp_list *self, void *v) {
    if (self->length >= self->alloc) {
        _tp_list_tp_realloc(self,self->alloc*2);
    }
    self->items[self->length] = v;
    self->length += 1;
}
void _tp_list_insert(_tp_list *self, int n, void *v) {
    if (self->length >= self->alloc) {
        _tp_list_tp_realloc(self,self->alloc*2);
    }
    memmove(&self->items[n+1],&self->items[n],sizeof(void*)*(self->length-n));
    self->items[n] = v;
    self->length += 1;
}
void *_tp_list_pop(_tp_list *self, int n, char *error) {
    void *r = _tp_list_get(self,n,error);
    if (!r) { return r; }
    memmove(&self->items[n],&self->items[n+1],sizeof(void*)*(self->length-(n+1)));
    self->length -= 1;
    return r;
}

int _tp_list_find(_tp_list *self, tp_obj v) {
    int n;
    for (n=0; n<self->length; n++) {
        if (tp_cmp(v,*(tp_obj*)self->items[n]).number.value==0) {
            return n;
        }
    }
    return -1;
}

tp_obj tp_index(tp_obj params) {
    P_BEGIN(params);
    tp_obj self = P_OBJ("self");
    tp_obj v = P_OBJ("value");
    P_END;
    int i = _tp_list_find(self.list.value,v);
    if (i < 0) { vm_raise("tp_index(%s,%s) - item not found",STR(self),STR(v)); }
    return tp_number(i);
}

_tp_list *_tp_list_new(int len) {
    _tp_list *self = tp_malloc(sizeof(_tp_list));
    self->items = 0;
    self->length = 0;
    self->alloc = 0;
    _tp_list_tp_realloc(self,len);
    return self;
}

_tp_list *_tp_list_copy(_tp_list *o) {
    _tp_list *r = _tp_list_new(o->alloc);
    memcpy(r->items,o->items,sizeof(void*)*o->alloc);
    r->length = o->length;
    return r;
}

tp_obj append(tp_obj params) {
    P_BEGIN(params);
    tp_obj self = P_OBJ("self");
    tp_obj v = P_OBJ("value");
    P_END;
    _tp_list_append(self.list.value,tp_ptr(v));
    return None;
}

tp_obj tp_pop(tp_obj params) {
    P_BEGIN(params);
    tp_obj self = P_OBJ("self");
    P_END;
    return *(tp_obj*)_tp_list_pop(self.list.value,self.list.value->length-1,"pop");
}

tp_obj insert(tp_obj params) {
    P_BEGIN(params);
    tp_obj self = P_OBJ("self");
    int n = P_NUMBER("index");
    tp_obj v = P_OBJ("value");
    P_END;
    _tp_list_insert(self.list.value,n,tp_ptr(v));
    return None;
}

tp_obj extend(tp_obj params) {
    P_BEGIN(params);
    tp_obj self = P_OBJ("self");
    tp_obj v = P_OBJ("value");
    P_END;
    int i;
    for (i=0; i<v.list.value->length; i++) {
        _tp_list_append(self.list.value,v.list.value->items[i]);
    }
    return None;
}

tp_obj tp_list(int len,tp_obj argv[]) {
    int i;
    tp_obj r;
    r.type = TP_LIST;
    r.list.value = _tp_list_new(len);
    for (i=0; i<len; i++) {
        _tp_list_append(r.list.value,tp_ptr(argv[i]));
    }
    return r;
}

int _sort_cmp(tp_obj*a,tp_obj*b) {
    return tp_cmp(*a,*b).number.value;
}

tp_obj tp_sort(tp_obj params) {
    P_BEGIN(params);
    tp_obj self = P_OBJ("self");
    P_END;
    qsort(self.list.value->items, self.list.value->length, sizeof(tp_obj *), (int(*)(const void*,const void*))_sort_cmp);
}



//


